image: mcr.microsoft.com/dotnet/sdk:latest
variables:
  PackageOutputPath: ./_out/pack
build:
  stage: build
  script:
    - dotnet pack
  artifacts:
   when: always
   expire_in: 1 day #we push everything to Artifactory, so we don't need to keep the build output for longer than one day
   paths:
     - ./_Root.csrpoj
     - ./_root
     - ./_out/*.binlog
     - $PackageOutputPath/*.*

test:
  stage: test
  dependencies:
    - build  #we depend on the build and pack stage, we only want to run when its successful, and we need its artifacts
  script:
    - dotnet test

push:
  stage: deploy
  dependencies:
   - build 
  script:
    - dotnet build /t:Push

pages:
 stage: deploy
 dependencies:
  - build
 script:
  - dotnet build /t:DeployPages
 artifacts:
  paths:
  - public